# Functions for getting variable/runtime data
#
# Copyright (C) 2015  Patrick McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

VARDATA_DIRS='mount'

vardatadir=

init_vardata()
{
	local tmpdir=''
	local dir=''

	if [ "x${TMPDIR:+set}" = 'xset' ]; then
		tmpdir="${TMPDIR}"
	else
		tmpdir='/tmp'
	fi

	rand
	vardatadir="${tmpdir}/${PACKAGE}-$(printf '%010d' ${rand_x})"
	if ! mkdir -- "${vardatadir}"; then
		error "$(get_msg 'temp_mkdir_fail')" "${vardatadir}"
		return 1
	fi
	for dir in ${VARDATA_DIRS}; do
		if ! mkdir -- "${vardatadir}/${dir}"; then
			error "$(get_msg 'temp_mkdir_fail')" \
				"${vardatadir}/${dir}"
			return 1
		fi
	done

	return 0
}

fini_vardata()
{
	local dir=''

	for dir in ${VARDATA_DIRS}; do
		if ! rmdir -- "${vardatadir}/${dir}"; then
			error "$(get_msg 'temp_rmdir_fail')" \
				"${vardatadir}/${dir}"
			return 1
		fi
	done
	if ! rmdir -- "${vardatadir}"; then
		error "$(get_msg 'temp_rmdir_fail')" "${vardatadir}"
		return 1
	fi

	return 0
}

get_vardata_dir()
{
	local dir="${1}"
	shift 1

	case " ${VARDATA_DIRS} " in
		*" ${dir} "*)
			printf '%s/%s' "${vardatadir}" "${dir}"
			;;
	esac

	return 0
}
